local function get_fam_item()
	-- TODO: Use familiar IDs/names instead
	local tw_item = 0
	if familiarpicture() == "jackinthebox" then
		tw_item = tw_item + 2 * fairy_bonus(buffedfamiliarweight())
	elseif familiarpicture() == "hounddog" then
		tw_item = tw_item + fairy_bonus(buffedfamiliarweight() * 1.25)
	elseif familiarpicture() == "spanglehat" and familiarid() == 82 then
		tw_item = tw_item + fairy_bonus(buffedfamiliarweight() * 2)
	elseif familiarpicture() == "spanglepants" and familiarid() == 152 then
		tw_item = tw_item + fairy_bonus(buffedfamiliarweight() * 2)
	end
	local vanilla_fairy = {
		"slimeling",
		"stompboots",
		"obtuseangel",
		"familiar15",
		"familiar22",
		"familiar26",
		"familiar34",
		"familiar35",
		"familiar36",
		"familiar39",
		"familiar41",
		"sgfairy",
		"slgfairy",
		"jitterbug",
		"dandylion",
		"cassagnome",
		"dancebear",
		"sugarfairy",
		"pictsie",
		"turtle",
		"gibberer",
		"grouper2",
		"dancfrog",
		"hippofam",
		"pianocat",
		"kloop",
	}
	for i,fam in ipairs(vanilla_fairy) do
		if familiarpicture() == fam then
			tw_item = tw_item + fairy_bonus(buffedfamiliarweight())
		end
	end
	return tw_item
end

local function get_equipment_item()
	local tw_item = 0
	if have_equipped("frosty halo") and not (equipment().weapon or equipment().offhand) then -- unarmed
		tw_item = tw_item + 25
	end
	if have_equipped("scratch 'n' sniff sword") or have_equipped("scratch 'n' sniff crossbow") then
		for i = 1, 3 do
			if applied_scratchnsniff_stickers()[i] == get_itemid("scratch 'n' sniff unicorn sticker") then
				tw_item = tw_item + 25
			end
		end
	end
	local count_ms = 0
	if have_equipped("monstrous monocle") then
		count_ms = count_ms + 1
	end
	if have_equipped("musty moccasins") then
		count_ms = count_ms + 1
	end
	if have_equipped("molten medallion") then
		count_ms = count_ms + 1
	end
	if count_ms == 1 then
		tw_item = tw_item + 5
	elseif count_ms == 2 then
		tw_item = tw_item + 20
	elseif count_ms == 3 then
		tw_item = tw_item + 45
	end
	local equipmentarray = {
		["Jekyllin hide belt"] = 36, -- Currently just gives average
		["Grimacite go-go boots"] = 30,
		["Grimacite gorget"] = 25,
		["Mr. Accessory Jr."] = 25,
		["miniature gravy-covered maypole"] = 25,
		["hypnodisk"] = 25,
		["chiptune guitar"] = 25,
		["astral mask"] = 20,
		["bounty-hunting helmet"] = 20,
		["plexiglass pants"] = 20,
		["ice pick"] = 15,
		["flaming pink shirt"] = 15,
		["bounty-hunting pants"] = 15,
		["bounty-hunting rifle"] = 15,
		["Radio KoL Maracas"] = 15,
		["plastic pumpkin bucket"] = 13,
		["little box of fireworks"] = 12.5,
		["Red Balloon of Valor"] = 11,
		["Order of the Silver Wossname"] = 11,
		["Uranium Omega of Temperance"] = 11,
		["bindlestocking"] = 10,
		["sleazy bindle"] = 10,
		["spooky bindle"] = 10,
		["Crimbo ukelele"] = 10,
		["flamin' bindle"] = 10,
		["freezin' bindle"] = 10,
		["stinkin' bindle"] = 10,
		["Purple Horseshoe of Honor"] = 10,
		["Lead Zeta of Chastity"] = 10,
		["Coily&trade;"] = 10,
		["bottle-rocket crossbow"] = 10,
		["Crimbo ukelele"] = 10,
		["PVC staff"] = 10,
		["straw hat"] = 10,
		["honeycap"] = 10,
		["Bag o' Tricks"] = 10,
		["bottle-rocket crossbow"] = 10,
		["Ellsbury's skull"] = 10,
		["Loathing Legion many-purpose hook"] = 10,
		["spiky turtle shield"] = 10,
		["Baron von Ratsworth's monocle"] = 10,
		["mayfly bait necklace"] = 10,
		["Blue Diamond of Honesty"] = 9,
		["Aluminum Epsilon of Humility"] = 9,
		["Green Clover of Justice"] = 8,
		["Zinc Delta of Tranquility"] = 8,
		["Yellow Moon of Compassion"] = 7,
		["Nickel Gamma of Frugality"] = 7,
		["BGE 'cuddly critter' shirt"] = 7,
		["lucky rabbit's foot"] = 7,
		["Orange Star of Sacrifice"] = 6,
		["Iron Beta of Industry"] = 6,
		["makeshift cape"] = 5,
		["observational glasses"] = 5,
		["Pink Heart of Spirit"] = 5,
		["Copper Alpha of Sincerity"] = 5,
		["eye of the Tiger-lily"] = 5,
		["fancy opera glasses"] = 5,
		-- ["Tuesday's ruby"] = 5
		["bat hat"] = 5,
		["miner's helmet"] = 5,
		["Grateful Undead T-shirt"] = 5,
		["octopus's spade"] = 5,
		["pixel boomerang"] = 5,
		["bubble bauble bow"] = 5,
		["cyber-mattock"] = 5,
		["duck-on-a-string"] = 5,
		["vampire duck-on-a-string"] = 5,
		["roboduck-on-a-string"] = 5,
		["duct tape sword"] = 5,
		["gnauga hide whip"] = 3,
		["Mr. Container"] = 3,
		["hemp backpack"] = 2,
		["Colonel Mustard's Lonely Spades Club Jacket"] = 2, -- 1-3%
		["Newbiesport&trade; backpack"] = 1,
		["stinky cheese eye"] = 1, -- Should increase with use

		["aerated diving helmet"] = -50,
		["rusty diving helmet"] = -50,
		["makeshift SCUBA gear"] = -100,
	}
	for itemequip, bonus in pairs(equipmentarray) do
		tw_item = tw_item + count_equipped(itemequip) * bonus
	end
	return tw_item
end
	
local function get_buff_item()
	local tw_item = 0
	local buffarray = {
		["Sole Soul"] = math.min(buffturns("Sole Soul"), 300),
		["The HeyDezebound Heart"] = math.min(buffturns("The HeyDezebound Heart"), 300),
		["Bubble Vision"] = math.min(101 - buffturns("Bubble Vision"), 0),
		["One Very Clear Eye"] = 100,
		["Your #1 Problem"] = 100,
		["Let's Go Shopping!"] = 75,
		["Melancholy Burden"] = 60,
		["Polka Face"] = math.min(55, 5 * level()),
		["Clyde's Blessing"] = 50,
		["Extra Sensory Perception"] = 50,
		["Perceptive Pressure"] = 50,
		["The Vitus Virus"] = 50,
		["Black Tongue"] = 30,
		["Blue Tongue"] = 30,
		["Cupcake of Choice"] = 30,
		["Hoity Toity"] = 30,
		["Broken Fast"] = 30,
		["Mmmmmelon"] = 30,
		["Rave Concentration"] = 30,
		["Super Vision"] = 25,
		["Dance Interpreter"] = 20,
		["Dilated Pupils"] = 20,
		["Disco Concentration"] = 20,
		["Fat Leon's Phat Loot Lyric"] = 20,
		["Holiday Biss"] = 20,
		["Juiced and Jacked"] = 20,
		["The Ballad of Richie Thingfinder"] = 20,
		["Hella Smooth"] = 20,
		["Quadrilled"] = 20,
		["Withered Heart"] = math.min(buffturns("Withered Heart"), 20),
		["Litterboxing"] = 15,
		["Peeled Eyeballs"] = 15,
		["Dancing Prowess"] = 15,
		["Joyful Resolve"] = 15,
		["Aspect of the GravyPlum Fairy"] = 10,
		["Bootyliciousness"] = 10,
		["Heart of Lavender"] = 10,
		["Hustlin'"] = 10,
		["Techno Bliss"] = 10,
		["Eye of the Seal"] = 10,
		["Ichorous Eyesight"] = 10,
		["Ocelot Eyes"] = 10,
		["Hip to Be Square Dancin'"] = 10,
		["Eggs-tra Sensory Perception"] = 10,
		["Weasels Underfoot"] = 10,
		["Ermine Eyes"] = 5,
		["Object Detection"] = 5,
		["Je Ne Sais Porquoise"] = 5,
		["La Bamba"] = 3,
		["Big Veiny Brain"] = -10,
		["Wasabi Sinuses"] = -10,
		["Braaaaaains"] = -50,
		["Socialismydia"] = -50,
		["Temporary Blindness"] = -50,
		-- ["Limber as Mortimer"] = ...,
	}
	for itembuff, item in pairs(buffarray) do 
		if buff(itembuff) then
			tw_item = tw_item + item
		end
	end
	
	if equipment().weapon == nil and equipment().offhand == nil then -- unarmed
		if have_skill("Kung Fu Hustler") and turnsthisrun() >= 30 then
			tw_item = tw_item + 20 --temporarily Expert Timing is hard coded as on iff unarmed		
		end
	end
	return tw_item
end

-- kolproxy_log_time_interval("run:" .. tostring(x.scriptname), x.f)

local function get_skill_item()
	local tw_item = 0
	local skillarray = {
		["Mad Looting Skillz"] = 20,
		["Powers of Observatiogn"] = 10,
		["Natural Born Scrabbler"] = 5,
		["Envy"] = 30,
		["Greed"] = -15,
	}
	for skill, item in pairs(skillarray) do
		if have_skill(skill) then
			tw_item = tw_item + item
		end
	end
	return tw_item
end

add_printer("/charpane.php", function()
	if character["show modifier estimates"] ~= "yes" then return end

	local tw_item = 0

	if ascension["zone.manor.quartet song"] == "Le Mie Cose Favorite" then
		tw_item = tw_item + 5
	end
	if moonsign() == "Packrat" then
		tw_item = tw_item + 10
	end

	tw_item = tw_item + get_skill_item()
	tw_item = tw_item + get_fam_item()
	tw_item = tw_item + get_buff_item()
	tw_item = tw_item + get_equipment_item()

	-- ToDo - Grimacite, Jeklynn Hyde, Stinky Cheese, Tuesday Ruby, Expert Timing, Check perms, LBOF range, Brimstone, Bounty Hunting Outfit
	
	print_charpane_value { normalname = "Item drops", compactname = "Item", value = string.format("%+.1f%%", floor_to_places(tw_item, 1)) }
end)
